#!/usr/bin/perl -I. -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# modify guest share access. while this handles two cases,
# it only gets one case at a time.
#
use Sauce::Config;
use CCE;

my $cce = new CCE(Namespace => 'FileShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

my (%settings, $err);

# change the user name
if ($old->{guestUser} ne $obj->{guestUser}) {
    my $uid = getpwnam($obj->{guestUser});

    if (defined($uid)) {
	$cce->bye('FAIL', '[[base-fileshare.userAlreadyTaken]]');
	exit 1;
    }
    
    `/usr/sbin/usermod -g '$obj->{guestGroup}' -l '$obj->{guestUser}' '$old->{guestUser}'`;
}

# change the user's group
`/usr/sbin/usermod -g '$obj->{guestGroup}' '$obj->{guestUser}'` if $old->{guestGroup} ne $obj->{guestGroup};

if ($old->{guestWorkGroup} ne $obj->{guestWorkGroup}) {
    my @oids = $cce->find('Workgroup', { 'name' => $old->{guestWorkGroup}},'');
    if (not @oids) {
	$cce->bye('FAIL', '[[base-fileshare.groupDoesntExist]]');
	exit 1;
    }

    $err = $cce->set($oids[0], '', { 'name' => $obj->{guestWorkGroup} });
    if ($err) {
	$cce->bye('FAIL', '[[base-fileshare.cantChangeGroup]]');
	exit 1;
    }

    # restore old permissions
    my $dir = Sauce::Config::groupdir_base . "/$obj->{guestWorkGroup}";
    my $uid = getpwnam(Sauce::Config::groupdir_owner);
    my $gid = (getpwnam($obj->{guestUser}))[3];
    chown($uid, $gid, $dir);
    chown($uid, $gid, "$dir/incoming");
    chown($uid, $gid, "$dir/incoming/.AppleDouble");
    chmod(02775, $dir);
    chmod(02773, "$dir/incoming");
    chmod(02773, "$dir/incoming/.AppleDouble"); 
}

$cce->bye('SUCCESS');
exit 0;
