#!/usr/bin/perl -I. -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# this just modifies the quota for the public share
use Quota;
use CCE;

my $BlocksPerMB = 1024;

my $cce = new CCE(Namespace => 'FileShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();

# sanity checking is good
my $user = $obj->{guestUser};
my ($uid, $dir) = (getpwnam($user))[2,7];
unless ($user and $uid) {
    $cce->bye('FAIL', '[[base-fileshare.invalidUser]]');
    exit 1;
}

unless (-d $dir) {
    $cce->bye('FAIL', '[[base-fileshare.invalidPath]]');
    exit 1;
}

my $dev = Quota::getqcarg($dir);
Quota::sync($dev);

# just blindly reset the quota. 
my ($softquota, $hardquota, $softinode, $hardinode);
my $quota = $obj->{guestQuota}*$BlocksPerMB;

# figure out the quota
if ($quota eq 0) { # no quota is really quota for one file
    $softquota = 1;
    $hardquota = 1;
    $softinode = 1;
    $hardinode = 1;
} elsif ($quota gt 0) {
    $softquota = $quota;
    $hardquota = $softquota + $BlocksPerMB;
}

# trailing parameters 0, 1 indicate group
if (Quota::setqlim($dev, $uid, $softquota, $hardquota, 
		   $softinode, $hardinode, 0, 1)) {
    $cce->bye('FAIL', '[[base-fileshare.cantSetQuota]]');
    exit 1;
}
    
$cce->bye('SUCCESS');
exit 0;
